NB. builds html/chm help files from scriptdoc notation
NB.
NB. INSTALL:
NB. 1. Copy this file to 'user\sdoc2xxx\sdoc2htm.ijs'
NB.
NB. 2. IMPORTANT! Make the following fixes manually:
NB.
NB.   A. jzgraph - NB.*psize v <- "v" was missing
NB.     |index error: scriptdef2
NB.     |   type=.    {.ndx{.top
NB.   FIX: insert "v" into the corresponding line in jzgraph.ijs
NB.
NB.   B. not found: scripts      system\main\scripts j
NB.   FIX: remove `scripts` line from ..\config\scripts.ijs
NB.
NB. USE:
NB. 1. Start J
NB.
NB. 2. Open script:
NB.         open 'user\sdoc2xxx\sdoc2htm.ijs'
NB.
NB. 3. Load the file:
NB.         load 'user\sdoc2xxx\sdoc2htm.ijs'
NB.
NB. 4. Build .htm and htmlhelp files for PUBLIC scripts:
NB.         docbuild''
NB.
NB. 5. Goto 'sdoc' folder
NB.
NB. 6. Test .htm files, by running 'index.htm'
NB.
NB. 7. Run MS HtmlHelp application with 'sdoc.hhp'
NB.    or adjust the 'sdochhc.bat' file to invoke commandline compiler
NB.
NB. 8. Test the 'sdoc.chm' file, by running it
NB.    NOTE: You should have MS IE v4.72.xxx or later
NB.
NB. The resuting .chm and .htm files can be found in jsdoc2h-b.zip
NB. for comparison and in case something goes wrong with your build.
NB.
NB. HELP:   scriptdoc'user\sdoc2xxx\sdoc2htm.ijs'
NB.
NB. NOTE: Folders for both source scripts and target docs
NB.       should be in J hierarchy
NB.
NB. VERSION: sdoc2htm v0.01
NB. Author: Oleg Kobchenko <olegyk@spin.vl.net.ua>

require'scriptdoc'
'z'require'system\packages\misc\html.ijs'

NB.*DOCNAME n name for target help files
DOCNAME=: 'sdoc'

NB.*DEFDOCDIR n default destination folder for documentation
DOCDIR=: DEFDOCDIR=: 'sdoc'

RELDIR=: JDIR_j_,DOCDIR,PATHSEP_j_

SCREXT=: 'ijs'

docfname=: 3 : 0
FILE=. RELDIR , 'htm',~_3}. JDIR_j_ relpath >{.docgetscripts_jscriptdoc_ y.
)

split=: ({.~ ; (}.~ >:)) i.&' '
assign=: 3 : ('(>0{y.)=: 3 : (>1{y.)';'empty 0')

relpath=: i.&0@:=/@,: }. ]

assign"1 split;._2 (0 : 0)
main '<html><head>',(head y.),'</head>',(body y.),'</html>',LF
head '<title>',y.,'</title>',(css y.),LF
css '<LINK REL=stylesheet HREF="',(,(,:'../')#~ +/'\'=path y.),'sdoc.css" TYPE="text/css">'
body '<body>',(name y.),(body1 y.),(detail y.),(tail y.),'</body>',LF
body1 '<blockquote>',(abstr y.),(summary y.),'</blockquote>'
name '<h1><tt>',(toupper y.),'</tt></h1>',LF
abstr (lead@;@[ , abstrbody@;@])/ scripthdr_jscriptdoc_ y.
lead '<h2>',(tohtml y.),'</h2>',LF
abstrbody '<pre>',(tohtml y.),'</pre>',LF
summary '<P><B>Defined items</B>',(sumt1''),(sumth''),(sumrows y.),'</table>',LF
sumt1 '<TABLE BORDER=1 BORDERCOLORLIGHT=#808080 BORDERCOLORDARK=#FFFFFF',sumt2''
sumt2 ' CELLPADDING=2 CELLSPACING=0><TR BGCOLOR=#C0C0C0>'
sumth '<TH ALIGN=LEFT>Name</TH><TH ALIGN=LEFT>Class</TH><TH ALIGN=LEFT>Description</TH>'
sumrows ; sumrow &.> <"1 ] 3{."1 scriptdefs_jscriptdoc_ y.
sumrow '<tr>',(sumterm >0{y.),(sumclass >1{y.),(sumcell tohtml >2{y.),'</tr>',LF
sumterm sumcell'<a href="#',y.,'"><tt>',y.,'</tt></a>'
sumclass sumcell>((;:'n a c v') i. <,y.){(;:'Noun Adv Conj Verb'),<,y.
sumcell '<td>',y.,'</td>'
detail '<dl>',(; (item&.>)@<"1^:(*@#) scriptdefs_jscriptdoc_ y.),'</dl>',LF
item '<dt>',(itemhead y.),'</dt><dd>',(itembody >3{y.),'</dd>',LF,LF
itemhead (itemterm >0{y.),' (',(>1{y.),') ',(tohtml >2{y.),'</h3></a>',LF
itemterm '<a name="',y.,'"><h3><tt>',(pad tohtml y.),'</tt>'
pad (, ,@(#&(,:'.')"_)@(0&>.)@(20&-)@#) y.
itembody '<pre>',(tohtml y.),'</pre>'
tail '<hr><table width=100%><tr>','<td>',(path y.),'</td>',(cr y.),'</tr></table>',LF
path JDIR_j_ relpath >{.docgetscripts_jscriptdoc_ y.
cr '<td align=right><i>Release:</i> ',(9!:14''),'</td>'
)

NB. main 'dll'

NB. safe creation of chain dirs
NB. e.g. mkdir &.> pathscan fullname_j_'sdoc\main'
pathscan=: [: }.^:(':'&e.@>@{.) [: }.@;&.>@(<\) [: (<;.1~ '\'&=) [: '\'&, }:^:('\'&=@{:)
mkdir=: (1!:5@<)^:(-.@*@#@(1!:0))

NB. e.g. topic 'dll'
NB. T=. topic &.> {.|: PUBLIC_j_
topic=: 3 : 0
smoutput y.
FILE=. docfname y.
mkdir &.> pathscan ({.~ i:&'\') FILE
FILE fwrite~ main y.
y.;FILE
)

dirhierarchy=: 3 : 0
'NUB KEY'=.((] ; <@i.~) ~.)@:((JDIR_j_&relpath)@({.~ i:&'\')&.>)@:(1&{"1) (/: 1&{"1) PUBLIC_j_
GROUPS=. KEY </. {.|: (/: 1&{"1) PUBLIC_j_
(<NUB),(<KEY),(<GROUPS)
)

hhcrow=: 3 : 0
's l d'=. y.
T=.TAB,'<li><OBJECT type="text/sitemap">',LF
T=.T,TAB,TAB,'<param name="Name" value="',s,'">',LF
T=.T,TAB,TAB,'<param name="Local" value="',l,'">',LF
T=.T,TAB,TAB,'<param name="Comment" value="',d,'"></OBJECT>',LF
)

hhc=: 3 : 0
'NUB KEY GROUPS'=. dirhierarchy''
R=. ''
smoutput ' hhc',~60#'-'
for_G. i.#GROUPS do.
smoutput ;:^:_1>G{GROUPS
T=. (;docfname) &.> >G{GROUPS
T=. (/: {:"1)> T      NB. sort
T=. (, {.@scripthdr_jscriptdoc_@{.)"1 T NB. add comment line
T=. 1 ((<@(RELDIR&relpath)@>@{)`[`])}"1 T
T=. ;hhcrow &.> <"1 T
T=. '<param name="Name" value="',(>G{NUB),'"></OBJECT><UL>',LF,T,'</UL>',LF
T=. '<LI><OBJECT type="text/sitemap">',T
R=. R, T
end.
T=. '<OBJECT type="text/site properties"><param name="Window Styles" value="0x1027">'
T=. T,'<param name="ImageType" value="Folder"></OBJECT>',LF
T=. T,'<UL><LI><OBJECT type="text/sitemap"><param name="Name" value="Contents">'
T=. T,'<param name="Local" value="',DOCNAME,'toc.htm"></OBJECT>',LF
T=. T,'<LI><OBJECT type="text/sitemap">'
T=. T,'<param name="Name" value="J Scripts"></OBJECT><ul>',LF
R=. '<body>',T,R,'</ul></UL></body>'
R=. '<html><HEAD><!-- Sitemap 1.0 --></HEAD>',LF,R,'</html>'
R fwrite RELDIR,DOCNAME,'.hhc'
)

tocrow=: 3 : 0
's l d'=. y.
'<tr><td><a href="',l,'"><tt>',s,'</tt></a></td><td>',(tohtml d),'</td></tr>',LF
)

toc=: 3 : 0
'NUB KEY GROUPS'=. dirhierarchy''
R=. ''
smoutput ' toc',~60#'-'
for_G. i.#GROUPS do.
smoutput ;:^:_1>G{GROUPS
T=. (;docfname) &.> >G{GROUPS
T=. (/: {:"1)> T      NB. sort
T=. (, {.@scripthdr_jscriptdoc_@{.)"1 T NB. add comment line
T=. 1 ((<@(RELDIR&relpath)@>@{)`[`])}"1 T
T=. ;tocrow &.> <"1 T
T=. '<b>',(>G{NUB),'</b>',LF,'<table cellspacing=0>',T,'</table><hr height=1>',LF
R=. R, T
end.
R=. '<body><h1 align=right>J Script Doc</h1>',R,'</body>'
R=. '<LINK REL=stylesheet HREF="sdoc.css" TYPE="text/css">',R
R=. '<html><title>J Scripts Contents</title>',LF,R,'</html>'
R fwrite RELDIR,DOCNAME,'toc.htm'
)

briefrow=: 3 : 0
's l d'=. y.
'<tr><td><a href="',l,'" title="',d,'" target="Main"><tt>',s,'</tt></a></td></tr>',LF
)

brief=: 3 : 0
'NUB KEY GROUPS'=. dirhierarchy''
R=. ''
smoutput ' brf',~60#'-'
for_G. i.#GROUPS do.
smoutput ;:^:_1>G{GROUPS
T=. (;docfname) &.> >G{GROUPS
T=. (/: {:"1)> T      NB. sort
T=. (, {.@scripthdr_jscriptdoc_@{.)"1 T NB. add comment line
T=. 1 ((<@(RELDIR&relpath)@>@{)`[`])}"1 T
T=. ;briefrow &.> <"1 T
T=. '<dt><h4>',(>G{NUB),'</h4></dt>',LF,'<dd><table cellspacing=0>',T,'</table></dd>',LF
R=. R, T
end.
R=. '<a href="',DOCNAME,'ndx.htm" target="Contents">Index</a></dt><hr size=1>',LF,R,LF
R=. '<dt><a href="',DOCNAME,'toc.htm" target="Main">Contents</a> | ',LF,R,LF
R=. '<body><dl>',R,'</dl></body>'
R=. '<LINK REL=stylesheet HREF="sdoc.css" TYPE="text/css">',R
R=. '<html><title>J Scripts Contents</title>',LF,R,'</html>'
R fwrite RELDIR,DOCNAME,'brf.htm'
)

index1=: 3 : 0
KWS=. ({."1)^:(*@#) scriptdefs_jscriptdoc_ y.
FILE=. RELDIR relpath docfname y.
T=. (<y.),"1~ KWS ,. <FILE
NB. (_1|.(<FILE) ,2#<y.) , T
((y.,' (script)');FILE;y.) , T
)

indexrow=: 3 : 0
'kw fl lib'=. y.
'<dt><a href="',fl,'" title="',lib,'" target="Main">',kw,'</a></dt>',LF
)

index=: 3 : 0
T=. index1 &.> {.|:PUBLIC_j_
T=. >(<@(,&>))/T
T=. (/: 0&(tolower&.>@{`[`]})"1) T
T=. ;indexrow &.> <"1 T
T=. '<dt><a href="',DOCNAME,'brf.htm" target="Contents">Contents</a></dt><hr size=1>',LF,T,LF
T=. '<body><dl>',T,'</dl></body>'
T=. '<LINK REL=stylesheet HREF="sdoc.css" TYPE="text/css">',T
T=. '<html><title>J Script Doc Index</title>',LF,T,'</html>'
T fwrite RELDIR,DOCNAME,'ndx.htm'
)

hhkrow=: 3 : 0
'kw fl lib'=. y.
T=.'<LI><OBJECT type="text/sitemap">',LF,TAB,'<param name="Name" value="',kw,'">'
T=.T,LF,TAB,'<param name="Local" value="',fl,'"></OBJECT>',LF
)

hhk=: 3 : 0
T=. index1 &.> {.|:PUBLIC_j_
T=. >(<@(,&>))/T
T=. (/: 0&(tolower&.>@{`[`]})"1) T
T=. ;hhkrow &.> <"1 T
T=. '<body><UL>',LF,T,'</UL></body>'
T=. '<html><HEAD><!-- Sitemap 1.0 --></HEAD>',LF,T,'</html>'
T fwrite RELDIR,DOCNAME,'.hhk'
)

getdirs=: #~ 'd'&=@(4&{)@>@{:"1

exttree=: 3 : 0
T=. {."1 ] 1!:0 y.,PATHSEP_j_,'*.',SCREXT
T=. tolower &.> T
T=. > T (_4&}.@[ ; (,~ ,&PATHSEP_j_)) &.> <y.
T=. (0 0&$)^:(''&-:) T
D=. {."1 getdirs 1!:0 y.,PATHSEP_j_,'*.*'
D=. (<y.,PATHSEP_j_) ,&.> tolower &.>D
D=. exttree &.> D
D=. (<T),D
(/: |."1) ><@(,&>) / D
)

NB.*buildall v run all scripts to build help files
NB.
NB. form: [DIRS] docbuild TARGETDIR
NB.   DIRS - char vector 'dir1;dir2;...;dirN;'
NB.   TARGETDIR - target docs directory in J hierarchy
NB.
NB. e.g.
NB.   docbuild ''                NB. for all PUBLIC_j_ scripts to DEFDOCDIR
NB.   'system;' docbuild 'sdoc'  NB. for all scripts in system hierarchy
NB.   docbuild 'publicdoc'       NB. all PUBLIC_j_ to 'publicdoc' folder
NB.
NB. NOTE: You can have different DOCNAME sets of docs in one TARGETDIR
NB.       However, you should rename index.thm files for each DOCNAME
docbuild=: 3 : 0
'' docbuild y.
:
PUBLICSAVE=: PUBLIC_j_
    try.
if. 0<#x. do. PUBLIC_j_=: (<''),~"1 ><@(,&>) /exttree &.> <;._2 x. end.
if. 0<#y. do. DOCDIR=: y. end.
RELDIR=: JDIR_j_,DOCDIR,PATHSEP_j_
T=. topic &.> {.|: PUBLIC_j_
brief''
toc''
hhc''
hhk''
index''
(HHP rplc 'DOCNAME';DOCNAME) fwrite DOCDIR,PATHSEP_j_,DOCNAME,'.hhp'
(INDEX rplc 'DOCNAME';DOCNAME) fwrite DOCDIR,PATHSEP_j_,'index.htm'
CSS fwrite DOCDIR,PATHSEP_j_,DOCNAME,'.css'
(toHOST BAT rplc 'DOCNAME';DOCNAME) fwrite DOCDIR,PATHSEP_j_,DOCNAME,'hhc.bat'
PUBLIC_j_=: PUBLICSAVE
'[ok]'
    catch.
PUBLIC_j_=: PUBLICSAVE
'[error]'
    end.
)

NB.====================================================
NB.*HHP n noun with customizable .hhp file
HHP=: 0 : 0
[OPTIONS]
Compatibility=1.0
Compiled file=DOCNAME.chm
Contents file=DOCNAME.hhc
Default topic=DOCNAMEtoc.htm
Display compile progress=Yes
Full-text search=Yes
Index file=DOCNAME.hhk
Language=0x409 English (United States)
Title=J Script Doc


[FILES]
DOCNAMEtoc.htm
)

NB.====================================================
NB.*INDEX n noun with customizable index.htm file
INDEX=: 0 : 0
<TITLE>J Script Doc</TITLE>

<FRAMESET cols="180, *">
        <FRAME SRC="DOCNAMEbrf.htm"
            NAME="Contents"
            MARGINWIDTH="2"
            SCROLLING="yes">
        <FRAME SRC="DOCNAMEtoc.htm"
            NAME="Main"
            MARGINWIDTH="6">
</FRAMESET>
)

NB.====================================================
NB.*CSS n noun with .css file
CSS=: 0 : 0
BODY {
font-family: Verdana, Helvetica, Arial;
font-size: 10pt;
}

H1 {
margin-bottom: 0;
margin-top: 0;
}

H2 {
margin-bottom: 12pt;
margin-top: 0;
font-size: 14pt;
}

H3 {
margin-bottom: 4pt;
margin-top: 8pt;
font-size: 10pt;
}

H4 {
margin-bottom: 0pt;
margin-top: 4pt;
font-size: 8pt;
font-weight: normal;
}

TH {
font-size: 10pt;
}

TD {
font-size: 9pt;
}

DT {
text-align: left;
margin-bottom: 0;
margin-top: 0;
font-size: 8pt;
font-family: Verdana, Helvetica, Arial;
}

BLOCKQUOTE {
margin-bottom: 0;
margin-top: 0;
}

P {
}

PRE {
margin-bottom: 0;
margin-top: 0;
font-family: monospace;
font-size: 9pt;
}

IMG {
border: 0;
}
)

NB.====================================================
NB.*BAT n noun with .bat file to call HtmlHelp compiler
NB.   Value of %HHC% may be set here in source
BAT=: 0 : 0
rem DOCNAMEhhc.bat file to call HtmlHelp compiler
rem Either set correct path in the following varible
rem or copy the hhc.exe into current folder and delete path

set HHC="c:\Program Files\HTML Help Workshop\hhc.exe"
%HHC% DOCNAME.hhp

rem After successful compilation remove the .hh* anf this .bat files
)
